#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <unordered_map>
#include <unordered_set>

using namespace std;

char buf[(int) 2e5];
int n;
vector<pair<string, int>> a;
const int p = 239;
const int MOD = 1000000007;

bool memes() {
    vector<pair<int, int>> ans;
    unordered_map<long long, unordered_set<int>> prefs;
    unordered_map<long long, int> strs;
    for (int i = 0; i < 2 * n; i++) {
        long long hsh = 0;
        bool ok = false;
        for (int j = 0; j < a[i].first.size(); j++) {
            hsh = (hsh * p + a[i].first[j]) % MOD;
            if (strs.count(hsh)) {
                int ind = strs[hsh];
                ans.push_back({i, ind});
                strs.erase(hsh);
                long long hsh1 = 0;
                for (int j = 0; j < a[ind].first.size(); j++) {
                    hsh1 = (hsh1 * p + a[ind].first[j]) % MOD;
                    prefs[hsh1].erase(ind);
                }
                ok = true;
                break;
            }
        }
        if (ok) continue;
        if (prefs.count(hsh) && !prefs[hsh].empty()) {
            int ind = *prefs[hsh].begin();
            prefs[hsh].erase(ind);
            ans.push_back({i, ind});
            ok = true;

            long long hsh1 = 0;
            for (int j = 0; j < a[ind].first.size(); j++) {
                hsh1 = (hsh1 * p + a[ind].first[j]) % MOD;
                prefs[hsh1].erase(ind);
            }
            strs.erase(hsh1);
        }
        if (ok) continue;

        long long h = 0;
        for (int j = 0; j < a[i].first.size(); j++) {
            h = (h * p + a[i].first[j]) % MOD;
            prefs[h].insert(i);
        }
        strs[h] = i;
    }

    if (ans.size() == n) {
        for (int i = 0; i < n; i++) {
            int i1 = ans[i].first, i2 = ans[i].second;
            if (a[i1].first.size() > a[i2].first.size()) {
                swap(i1, i2);
            }

            cout << a[i1].second + 1 << " " << a[i2].second + 1 << '\n';
        }
        return true;
    }
    return false;
}

void shuffle() {
    for (int i = 0; i < 2 * n; i++) {
        int j = i + rand() % (2 * n - i);
        swap(a[i], a[j]);
    }
}

void srt() {
    vector<pair<int, int>> lens(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        lens[i] = {a[i].first.size(), i};
    }
    sort(lens.begin(), lens.end());
    vector<pair<string, int>> a1;
    for (int i = 0; i < 2 * n; i++) {
        a1.push_back(a[lens[i].second]);
    }
    a.swap(a1);
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    srand(228239);
    scanf("%d", &n);
    a.resize(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        scanf("%s", buf);
        a[i] = {string(buf), i};
    }

    srt();
    if (memes()) {
        return 0;
    }
    while (true) {
        shuffle();
        if (memes()) {
            return 0;
        }
    }
}
