#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cstdlib>
#include <utility>
#include <memory.h>
#include <cassert>
#include <iterator>
#include <bitset>
#include <iomanip>
#include <complex>
#include <queue>
#include <ctime>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second

const int N = 500500;

int n;
int timer = 0;
int tin[N];
int ans[N];
int len[N];
char *s[N];
char ss[N];
bool used[N];

struct node {
    node *nxt[26];
    vector<int> who;
    node () {
        for (int i = 0; i < 26; ++i) {
            nxt[i] = NULL;
        }
        who.reserve(5);
    }
};

node *root = NULL;

void add(int id) {
    node *cur = root;
    for (int i = 1; i <= len[id]; ++i) {
        int code = (int)s[id][i] - (int)'a';
        if (!cur -> nxt[code]) {
            cur -> nxt[code] = new node();
        }
        cur = cur -> nxt[code];
    }
    cur -> who.push_back(id);
}

vector<int> have;

void dfs(node *ver) {
    if (!ver) return;
    ++timer;
    for (int x: ver -> who) {
        have.push_back(x);
        tin[x] = timer;
    }
    for (int i = 0; i < 26; ++i) {
        dfs(ver -> nxt[i]);
    }
    for (int x: ver -> who) {
        used[x] = true;
    }
    while (have.size() > 1) {
        int x = have.back();
        if (!used[x]) {
            break;
        }
        have.pop_back();
        int y = have.back();
        have.pop_back();
        ans[y] = x;
    }
    if (have.size() == 1 && used[have.back()]) {
        have.pop_back();
    }
    for (int x: ver -> who) {
        used[x] = false;
    }
}

int main() {
    root = new node();
    scanf("%d\n", &n);
    for (int i = 1; i <= n + n; ++i) {
        ans[i] = -1;
        gets(ss + 1);
        len[i] = (int)strlen(ss + 1);
        s[i] = new char[len[i] + 10];
        for (int j = 0; j <= len[i] + 1; ++j) {
            s[i][j] = ss[j];
        }
    }
    for (int i = 1; i <= n + n; ++i) {
        add(i);
    }
    dfs(root);
    vector< pair<int, int> > result;
    for (int i = 1; i <= n + n; ++i) {
        if (ans[i] != -1) {
            result.push_back(make_pair(ans[i], i));
        }
    }
    for (auto it: result) {
        printf("%d %d\n", it.F, it.S);
    }
    return 0;
}