#include <iostream>
#include <vector>

using namespace std;

const int MAXX = 1001;
const int MAXN = 101;
const int INF = (int) 1e9;

int dp[MAXX][MAXN];

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    int n, x;
    scanf("%d%d", &n, &x);
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
    }

    for (int i = 0; i < MAXX; i++) {
        fill(dp[i], dp[i] + MAXN, INF);
    }

    dp[0][0] = 0;
    for (int u = 0; u < x; u++) {
        for (int i = 0; i < n; i++) {
            int j, v;

            j = 0;
            v = u;
            dp[v % MAXX][j] = min(dp[v % MAXX][j], dp[u % MAXX][i] + 1);
        }

        for (int i = 0; i < n; i++) {
            int j, v;

            j = min(n - 1, i + 1);
            v = u + a[i];
            dp[v % MAXX][j] = min(dp[v % MAXX][j], dp[u % MAXX][i] + 1);
        }

        fill(dp[u % MAXX], dp[u % MAXX] + MAXN, INF);
    }

    int mn = INF;
    for (int i = 0; i < n; i++) {
        mn = min(mn, dp[x % MAXX][i]);
    }

    if (mn == INF) {
        cout << -1 << endl;
    } else {
        cout << mn << endl;
    }

    return 0;
}
