#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 1e6 + 5;

int in[MAXN], out[MAXN];
int sz[MAXN];
int depth[MAXN];
int parent[MAXN];
int t;
vector<int> graph[MAXN];
vector<int> order;

int dfs(int v, int p, int d = 0) {
    parent[v] = p;
    depth[v] = d;
    order.puba(v);
    sz[v] = 1;
    in[v] = t++;
    for (int to : graph[v]) {
        if (to != p) {
            dfs(to, v, d + 1);
            sz[v] += sz[to];
        }
    }
    out[v] = t;
    return 0;
}

int go_up(int v, int d) {
    if (v == 0 || d == 0) {
        return v;
    }
    return go_up(parent[v], d - 1);
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc >= 5);

    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int q = atoi(argv[3]);
    int dist = atoi(argv[4]);

    cout << n << "\n";

    int shift = min(3, max(1, n / 10));
    vector<int> nodes_order;
    for (int i = 0; i < n; ++i) {
        nodes_order.puba(i);
    }
    shuffle(nodes_order.begin() + 1, nodes_order.end());

    vector<pii> edges;
    for (int i = 0; i < n - 1; ++i) {
        int a = nodes_order[i + 1];
        int b = nodes_order[rnd.next(max(0, i - shift + 1), i)];
        if (rnd.next(0, 1)) {
            swap(a, b);
        }
        graph[a].puba(b);
        graph[b].puba(a);
        edges.puba({a, b});
    }

    shuffle(bend(edges));

    for (pii e : edges) {
        cout << e.ff + 1 << " " << e.ss + 1 << "\n";
    }

    dfs(0, 0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < szof(graph[i]); ++j) {
            if (depth[i] > depth[graph[i][j]]) {
                graph[i].erase(graph[i].begin() + j);
                break;
            }
        }
    }

    cout << m << "\n";
    
    int tmp = m;
    if (tmp >= n - 1) {
        tmp -= n - 1;
        for (int i = 1; i < n; ++i) {
            int v = i;
            int u = go_up(v, rnd.next(1, dist));
            cout << v + 1 << " " << u + 1 << "\n";
        }
    }
    
    for (int i = 0; i < tmp; ++i) {
        int v = rnd.next(1, n - 1);
        int u = go_up(v, rnd.next(1, dist));
        cout << v + 1 << " " << u + 1 << "\n";
    }

    cout << q << "\n";

    tmp = q;
    if (tmp >= n) {
        tmp -= n;
        for (int i = 0; i < n; ++i) {
            cout << i + 1 << " " << m << "\n";
        }
    }
    
    for (int i = 0; i < tmp; ++i) {
        int v = rnd.next(0, n - 1);
        int k = rnd.next(0, m);
        cout << v + 1 << " " << k << "\n";
    }

    return 0;
}