#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) (_x).begin(), (_x).end()
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int MAXN = 200000;

vector<int> graph[MAXN];
int tin[MAXN], out[MAXN];
bool used[MAXN];
int t;

int dfs(int v) {
    tin[v] = t++;
    used[v] = true;
    for (int to : graph[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    out[v] = t++;
    return 0;
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    
    int n = inf.readInt(2, MAXN, "n");
    inf.readEoln();

    for (int i = 0; i < n - 1; ++i) {
        int a = inf.readInt(1, n, "a") - 1;
        inf.readSpace();
        int b = inf.readInt(1, n, "v") - 1;
        inf.readEoln();
        graph[a].puba(b);
        graph[b].puba(a);
    }
    dfs(0);

    for (int i = 0; i < n; ++i) {
        ensuref(used[i], "graph isn't a tree");
    }

    int m = inf.readInt(0, MAXN, "m");
    inf.readEoln();
    
    for (int i = 0; i < m; ++i) {
        int u = inf.readInt(1, n, "u") - 1;
        inf.readSpace();
        int v = inf.readInt(1, n, "v") - 1;
        inf.readEoln();
        ensuref(tin[v] < tin[u] && out[u] < out[v], "%d must be a child of %d", u + 1, v + 1);
    }

    int q = inf.readInt(0, MAXN, "q");
    inf.readEoln();
    for (int i = 0; i < q; ++i) {
        int v = inf.readInt(1, n, "from") - 1;
        inf.readSpace();
        int k = inf.readInt(0, m, "k");
        inf.readEoln();
    }

    inf.readEof();

    return 0;
}