#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 1000;
char s[MAXN];
vector<string> a;
int n, m;

void hor() {
    vector<int> l(n, -1), r(n, -1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '*') {
                if (l[i] == -1) {
                    l[i] = j;
                }
                r[i] = j;
            }
        }

        if (l[i] != -1) {
            for (int j = l[i]; j <= r[i]; j++) {
                a[i][j] = '*';
            }
        }
    }
}

void vert() {
    vector<int> l(m, -1), r(m, -1);
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            if (a[i][j] == '*') {
                if (l[j] == -1) {
                    l[j] = i;
                }
                r[j] = i;
            }
        }

        if (l[j] != -1) {
            for (int i = l[j]; i <= r[j]; i++) {
                a[i][j] = '*';
            }
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif

    scanf("%d%d", &n, &m);
    a.resize(n);
    for (int i = 0; i < n; i++) {
        scanf("%s", s);
        a[i] = string(s);
    }

    for (int i = 0; i < 500; i++) {
        hor();
        vert();
    }

    for (int i = 0; i < n; i++) {
        cout << a[i] << '\n';
    }

    return 0;
}