#include "testlib.h"
using namespace std;
const int N = 3e5;

int n;
string strs[N];
bool used[N];

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    inf.readLine();
    for (int i = 0; i < 2 * n; ++i) {
        string str = inf.readLine();
        strs[i] = str;
    }

    for (int i = 0; i < n; ++i) {
        int ind1 = ouf.readInt(1, 2 * n, "str_i");
        int ind2 = ouf.readInt(1, 2 * n, "str_i");
        ind1--;
        ind2--;
        quitif(used[ind1] == true, _pe, "Index %d is met twice.", ind1 + 1);
        quitif(used[ind2] == true, _pe, "Index %d is met twice.", ind2 + 1);
        used[ind1] = true;
        used[ind2] = true;
        quitif(strs[ind1].size() > strs[ind2].size(), _wa, "In pair #%d, login is longer than password", i + 1);
        for (int j = 0; j < (int)strs[ind1].size(); j++) {
            quitif(strs[ind1][j] != strs[ind2][j], _wa, 
                "String %d is not prefix of string %d.", ind1 + 1, ind2 + 1);
        }
    }

    quitf(_ok, "ok");
    return 0;
}