#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <vector>
#include <deque>

using namespace std;

const int MAXN = 100;
unordered_map<int, int> d[MAXN];

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif

    int n, x;
    scanf("%d%d", &n, &x);
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
    }

    deque<pair<int, int>> q;
    d[0][0] = 0;
    q.push_back({0, 0});
    while (!q.empty()) {
        auto pu = q.front();
        q.pop_front();
        int ind = pu.first, val = pu.second;
        int ind1;
        int val1;
        int du = d[ind][val];

        val1 = val + a[ind];
        if (val1 <= x) {
            ind1 = ind + (ind == n - 1 ? 0 : 1);

            if (!d[ind1].count(val1)) {
                d[ind1][val1] = du + 1;
                if (val1 == x) {
                    cout << du + 1 << endl;
                    return 0;
                }
                q.push_back({ind1, val1});
            }
        }

        val1 = val;
        ind1 = 0;
        if (!d[ind1].count(val1)) {
            d[ind1][val1] = du + 1;
            q.push_back({ind1, val1});
        }
    }

    cout << -1 << endl;

    return 0;
}