#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MAXN = 1e6 + 5;
vector<pii> graph[MAXN];
int depth[MAXN];

int dfs(int v, int p, int d) {
    depth[v] = d;
    for (pii to : graph[v]) {
        if (to.ff != p) {
            dfs(to.ff, v, d + 1);
        }
    }
    return 0;
}

bool used[MAXN];
int dist[MAXN];

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    int n, m, q;
    scanf("%d", &n);

    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a; --b;
        graph[a].puba({b, 0});
        graph[b].puba({a, 0});
    }

    dfs(0, 0, 0);

    scanf("%d", &m);
    
    for (int i = 0; i < m; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a; --b;
        graph[a].puba({b, 1});
    }

    scanf("%d", &q);

    for (int i = 0; i < q; ++i) {
        //cerr << i << endl;
        int v, k;
        scanf("%d%d", &v, &k);
        --v;
        deque<int> dq;
        dq.puba(v);
        memset(used, 0, sizeof used);
        fill(dist, dist + n, INF);
        dist[v] = 0;

        while (szof(dq)) {  
            /*
            for (int num : dq) {
                cerr << num << " ";
            }
            cerr << endl;*/
            int u = dq.front();
            dq.pop_front();
            //cerr << "~ " << u << endl;
            while (szof(dq) && used[u]) {
                //cerr << "skip " << u << endl;
                u = dq.front();
                dq.pop_front();
            }
            if (used[u]) {
                break;
            }
            
            used[u] = true;

            //cerr << u << " " << dist[u] << endl;
            if (dist[u] > k) {
                break;
            }

            for (pii to : graph[u]) {
                //cerr << "here " << to.ff << " " << to.ss << endl;
                if (!to.ss) {
                    if (depth[to.ff] > depth[u]) {
                        if (dist[to.ff] > dist[u]) {
                            dist[to.ff] = dist[u];
                            dq.push_front(to.ff);
                        }
                    }
                } else {
                    if (dist[to.ff] > dist[u] + 1) {
                        //cerr << "add" << endl;
                        dist[to.ff] = dist[u] + 1;
                        dq.push_back(to.ff);
                    }
                }
            }
        }

        int ans = v;

        for (int j = 0; j < n; ++j) {
            if (dist[j] <= k) {
                if (depth[ans] > depth[j]) {
                    ans = j;
                }
            }
        }
        cout << ans + 1 << "\n";
        
    }
    
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}                                        